﻿using Infragistics.Controls.Menus;
using Infragistics.Controls.Primitives;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;
using System.Windows.Threading;
using WpfApplication1.Helpers;
using WpfApplication1.Model;

namespace WpfApplication1.ViewModel
{
    public class MainWindowViewModel : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        private ObservableCollection<Category> _items = new ObservableCollection<Category>();
        public ObservableCollection<Category> Items
        {
            get { return _items; }
            set
            {
                if (_items != value)
                {
                    _items = value;
                    OnPropertyChanged("Items");
                }
            }
        }


        private Category _item = new Category();
        public Category SelectedItem
        {
            get { return _item; }
            set
            {
                if (_item != value)
                {
                    _item = value;
                    OnPropertyChanged("SelectedItem");
                }
            }
        }

        public ICommand RemoveItem
        {
            get
            {
                return new RelayCommand<object>(
                    new Action<object>(
                        (obj) =>
                        {
                           //you can implement your logic here
                        }
                ));
            }
        }

        public MainWindowViewModel()
        {
            Items = DataUtil.CategoriesAndProducts;
        }

        public void XamDataTree_Loaded(object sender, RoutedEventArgs e)
        {
            this.SetNodeExpandedState((sender as XamDataTree).Nodes, true);
        }

        private void SetNodeExpandedState(IEnumerable<XamDataTreeNode> nodes, bool expandNode)
        {
            foreach (XamDataTreeNode item in nodes)
            {
                item.IsExpanded = expandNode;

                Application.Current.Dispatcher.BeginInvoke(new Action(() =>
                {
                    var expBtn = Infragistics.Windows.Utilities.GetDescendantFromType(item.Control, typeof(ExpansionIndicator), true) as ExpansionIndicator;
                    if (null != expBtn)
                        expBtn.Visibility = Visibility.Collapsed;
                }), System.Windows.Threading.DispatcherPriority.SystemIdle);
                
                this.SetNodeExpandedState(item.Nodes, expandNode);
            }
        }
    }
}
